Home Information Classes Download Usage Mail List Requirements Links Tutorial

# TwoZero Class Reference

STK two-zero filter class. More...

`#include <TwoZero.h>`

Inheritance diagram for TwoZero:

List of all members.

## Public Member Functions

| TwoZero ()
| Default constructor creates a second-order pass-through filter.
| ~TwoZero ()
| Class destructor.
void | clear (void)
| Clears the internal states of the filter.
void | setB0 (MY_FLOAT b0)
| Set the b[0] coefficient value.
void | setB1 (MY_FLOAT b1)
| Set the b[1] coefficient value.
void | setB2 (MY_FLOAT b2)
| Set the b[2] coefficient value.
void | setNotch (MY_FLOAT frequency, MY_FLOAT radius)
| Sets the filter coefficients for a "notch" at frequency (in Hz).
void | setGain (MY_FLOAT theGain)
| Set the filter gain.
MY_FLOAT | getGain (void) const
| Return the current filter gain.
MY_FLOAT | lastOut (void) const
| Return the last computed output value.
MY_FLOAT | tick (MY_FLOAT sample)
| Input one sample to the filter and return one output.
MY_FLOAT * | tick (MY_FLOAT *vector, unsigned int vectorSize)
| Input vectorSize samples to the filter and return an equal number of outputs in vector.

## Detailed Description

STK two-zero filter class.

This protected Filter subclass implements a two-zero digital filter. A method is provided for creating a "notch" in the frequency response while maintaining a constant filter gain.

by Perry R. Cook and Gary P. Scavone, 1995 - 2002.

Definition at line 20 of file TwoZero.h.

## Member Function Documentation

void TwoZero::setNotch | ( | MY_FLOAT | frequency,
|  | MY_FLOAT | radius
| ) |

Sets the filter coefficients for a "notch" at frequency (in Hz).

This method determines the filter coefficients corresponding to two complex-conjugate zeros with the given frequency (in Hz) and radius from the z-plane origin. The coefficients are then normalized to produce a maximum filter gain of one (independent of the filter gain parameter). The resulting filter frequency response has a "notch" or anti-resonance at the given frequency. The closer the zeros are to the unit-circle (radius close to or equal to one), the narrower the resulting notch width.

void TwoZero::setGain | ( | MY_FLOAT | theGain | ) | `[virtual]`

| Set the filter gain. The gain is applied at the filter input and does not affect the coefficient values. The default gain value is 1.0. Reimplemented from Filter.

The documentation for this class was generated from the following file:

- TwoZero.h

The Synthesis ToolKit in C++ (STK)
©1995-2004 Perry R. Cook and Gary P. Scavone. All Rights Reserved.